#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire900one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire900one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one9004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


                             
# -------------------------------------------------------------------------------------------------
# 900
# -------------------------------------------------------------------------------------------------                                          
shot2one9004xi = {
                  1:'0x0y899z',
                  2:'0x1y899z',
                  3:'0x27y899z',
                  4:'0x595y674z',
                  5:'0x9y899z',
                  6:'113x824y342z',
                  7:'118x556y697z',
                  8:'123x788y416z',
                  9:'127x657y600z',
                  10:'127x727y514z',
                  11:'12x753y492z',
                  12:'12x88y895z',
                  13:'13x23y899z',
                  14:'145x542y703z',
                  15:'155x813y351z',
                  16:'15x32y899z',
                  17:'15x79y896z',
                  18:'160x644y607z',
                  19:'163x776y424z',
                  20:'164x714y522z',
                  21:'171x527y709z',
                  22:'17x41y898z',
                  23:'17x69y897z',
                  24:'18x50y898z',
                  25:'18x60y897z',
                  26:'192x629y613z',
                  27:'196x510y714z',
                  28:'197x801y359z',
                  29:'1x18y899z',
                  30:'200x699y529z',
                  31:'203x762y432z',
                  32:'219x493y719z',
                  33:'222x612y620z',
                  34:'234x683y536z',
                  35:'237x786y367z',
                  36:'241x474y725z',
                  37:'241x747y439z',
                  38:'24x687y580z',
                  39:'252x594y626z',
                  40:'262x455y730z',
                  41:'268x664y543z',
                  42:'26x0y899z',
                  43:'26x838y326z',
                  44:'277x769y375z',
                  45:'278x729y447z',
                  46:'280x574y633z',
                  47:'282x434y735z',
                  48:'28x22y899z',
                  49:'300x413y740z',
                  50:'300x645y551z',
                  51:'306x553y639z',
                  52:'30x588y680z',
                  53:'314x709y455z',
                  54:'315x750y383z',
                  55:'316x391y746z',
                  56:'331x368y751z',
                  57:'331x623y558z',
                  58:'332x531y646z',
                  59:'33x29y898z',
                  60:'345x345y755z',
                  61:'349x688y463z',
                  62:'352x729y392z',
                  63:'355x507y652z',
                  64:'357x321y760z',
                  65:'360x600y565z',
                  66:'367x297y765z',
                  67:'376x273y770z',
                  68:'377x483y658z',
                  69:'382x664y470z',
                  70:'388x576y572z',
                  71:'388x706y400z',
                  72:'38x37y898z',
                  73:'398x458y664z',
                  74:'40x805y400z',
                  75:'414x550y579z',
                  76:'414x639y478z',
                  77:'417x431y670z',
                  78:'422x681y408z',
                  79:'42x45y897z',
                  80:'434x404y676z',
                  81:'438x523y585z',
                  82:'444x613y486z',
                  83:'449x377y682z',
                  84:'455x655y416z',
                  85:'461x495y592z',
                  86:'463x349y688z',
                  87:'46x55y897z',
                  88:'472x585y493z',
                  89:'475x320y694z',
                  90:'482x466y599z',
                  91:'486x627y424z',
                  92:'48x64y896z',
                  93:'499x556y501z',
                  94:'4x107y893z',
                  95:'501x436y606z',
                  96:'50x74y895z',
                  97:'516x597y432z',
                  98:'519x406y612z',
                  99:'51x746y499z',
                  100:'524x525y508z',
                  101:'534x374y619z',
                  102:'543x566y439z',
                  103:'547x494y516z',
                  104:'568x461y523z',
                  105:'569x534y447z',
                  106:'56x94y993z',
                  107:'587x428y530z',
                  108:'592x500y455z',
                  109:'59x679y587z',
                  110:'5x7y899z',
                  111:'60x579y686z',
                  112:'614x466y463z',
                  113:'70x832y334z',
                  114:'82x797y408z',
                  115:'8x98y894z',
                  116:'90x568y692z',
                  117:'90x737y507z',
                  118:'94x669y593z',
                  119:'9x15y899z'}
                                          

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire900one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire900one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE90ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE90ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE90ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE90ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE90ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE9004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one9004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE90ONE4XI - SUCCEEDED TO PUT SHOT2ONE9004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE9004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE90ONE4XI *** FAILED TO PUT SHOT2ONE9004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE90ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one9004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one9004xi</nack2put4xi>" 
                     
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------

        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE90ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one9004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time 
        
    except:
        print(" (STEP 3C/33) OF FIRE90ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE90ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire900one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
